using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace drugiZadatak
{
    class Program
    {   
        static void DrugiSlucaj(long[] druzeljubivost, int[] x, int[] y, int[] brojPoznanika, ref bool[] provera)
        {
            for (int i = 0; i < x.Length; i++)
            {
                if (druzeljubivost[x[i] - 1] < 0)
                {
                    provera[x[i] - 1] = false;
                    provera[y[i] - 1] = false;
                }
                else if (druzeljubivost[y[i] - 1] < 0)
                {
                    provera[x[i] - 1] = false;
                    provera[y[i] - 1] = false;
                }
                else
                {
                    provera[x[i] - 1] = true;
                    provera[y[i] - 1] = true;
                }
            }
        }
        static void PrviSlucaj(long[] druzeljubivost, int[] x, int[] y, int[] brojPoznanika, ref bool[] provera)
        {
            for (int i = 0; i < x.Length; i++)
            {
                if(druzeljubivost[x[i] - 1] > 0)
                {
                    provera[x[i] - 1] = true;
                    provera[y[i] - 1] = true;
                }
                else if (druzeljubivost[y[i] - 1] > 0)
                {
                    provera[x[i] - 1] = true;
                    provera[y[i] - 1] = true;
                }
            }
        }
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);
            int m = int.Parse(s[1]);

            long[] druzeljubivost = new long[n];
            int[] x = new int[m];
            int[] y = new int[m];

            bool[] provera1 = new bool[n];
            bool[] provera2 = new bool[n];

            int[] brojPoznanika = new int[n];

            for (int i = 0; i < n; i++)
            {
                druzeljubivost[i] = long.Parse(Console.ReadLine());
            }
            for (int i = 0; i < m; i++)
            {
                s = Console.ReadLine().Split();
                x[i] = int.Parse(s[0]);
                y[i] = int.Parse(s[1]);

                brojPoznanika[x[i] - 1]++;
                brojPoznanika[y[i] - 1]++;
            }

            long sreca1 = 0;
            long sreca2 = 0;

            PrviSlucaj(druzeljubivost, x, y, brojPoznanika, ref provera1);
            DrugiSlucaj(druzeljubivost, x, y, brojPoznanika, ref provera2);

            for (int i = 0; i < druzeljubivost.Length; i++)
            {
                if (provera1[i] == true)
                {
                    sreca1 += druzeljubivost[i] * brojPoznanika[i];
                }
                else
                {
                    sreca1 -= druzeljubivost[i] * brojPoznanika[i];
                }

                if (provera2[i] == true)
                {
                    sreca2 += druzeljubivost[i] * brojPoznanika[i];
                }
                else
                {
                    sreca2 -= druzeljubivost[i] * brojPoznanika[i];
                }
            }

            if (sreca1 > sreca2)
            {
                Console.WriteLine(sreca1);
            }
            else
            {
                Console.WriteLine(sreca2);
            }
        }
    }
}